#!/usr/bin/perl -w
#
# dansguardianoff.pl
# Ermöglicht das temporäre eintragen aller Rechner
# eines Raums in die Datei 
# /etc/dansguardian/exceptioniplist.tmp
# um für diese die Filterung durch Dansguardian 
# auszuschakten
# (c) Frank Schiebel (Frank.Schiebel@ua25.de), Juli 2005 
use strict;
use CGI qw /:standard/;         # function-oriented interface

my $WIMPORT = "/usr/local/rembo/files/global/wimport_data";
my $TMPEXIP = "/etc/dansguardian/exceptioniplist.tmp";
my $ROOM = $ARGV[0];
my $ACTION = $ARGV[1] || "remove";
my $LOCK = "/var/lock/dansguardiantmp.lock";

my $line; my $room; my %rooms; my $roomsoff; my @hosts; my $host; my @lines;

get_host_ips_in_room($ROOM);

if( -e $LOCK ) {
   print "Ein anderer Benutzer bearbeitet derzeit die Ausnahmenliste, bitte versuchen Sie es zu einem anderen Zeitpunkt nochmals";
   exit 1;
}

system("echo $$ > $LOCK");

if ( $ACTION eq "removeall" ) {
	system("echo > $TMPEXIP");
}

if ( $ACTION eq "status" ) {
	print "<h2>Status der Internetfilterung</h2>";
        open TMPLIST, "<$TMPEXIP" or die "Probleme beim oeffnen der Datei $TMPEXIP\n";
        while($line=<TMPLIST>) {
                chomp($line);
		get_room_for_ip($line);
		}
        close TMPLIST;
        $roomsoff=0;
	foreach $room (keys %rooms) {
		$roomsoff=1; 
		print "<font color=\"red\"><b>Keine</b></font> Filterung  fr Raum <b>$room</b><br>"; 

	}
        if(!$roomsoff){ print "Alle Rume sind gefiltert, es gelten die vom Administrator festgelegten Ausnahmen.";}

}

if ( $ACTION eq "remove" ) {
	print "Entferne die Rechner von Raum $ROOM aus der Freigabenliste.\n";
        open TMPLIST, "<$TMPEXIP" or die "Probleme beim oeffnen der Datei $TMPEXIP\n";
        while($line=<TMPLIST>) {
                foreach $host (@hosts) {
			if( $line =~ /$host\s*$/ ) {$line=""; }	
			}
                push @lines,$line;
		}
        close TMPLIST;
        # Jetzt neu schreiben 
        open TMPLIST, ">$TMPEXIP" or die "Probleme beim oeffnen der Datei $TMPEXIP\n";
	foreach $line (@lines) {
  		print TMPLIST $line;
		}
        close TMPLIST;
}
 
if ( $ACTION eq "add" ) {
 
	print "Trage die Rechner von Raum $ROOM in die Freigabenliste ein.\n";
	foreach $host (@hosts) {
 	        if( ! `grep $host\$ $TMPEXIP` ) {  
			system("echo $host >> $TMPEXIP");
		}
	}
}
# Dansguardian neu starten..
if (!($ACTION eq "status") ) {
	system("/etc/init.d/dansguardian restart");
}
system("rm $LOCK");

# Diese Funktion ermittelt aus der wimport_data den zu einer IP 
# gehoerigen Raum.
# Als Argument wird eine IP erwartet.
sub get_room_for_ip {

    my $ip = $_[0];

    open INPUT, $WIMPORT || die " Kann $WIMPORT nicht zum lesen oeffnen!";
    while(<INPUT>) {
                if( /^(.*?);.*?;.*?;.*?;$ip;.*$/ ){
                $rooms{$1}=1;
                }
        }
    }
# Diese Funktion ermittelt aus der wimport_data alle zu einem Raum
# gehoerigen Rechner.
# Als Argument wird ein Raumname erwartet.
sub get_host_ips_in_room {

    my $room = $_[0];

    open INPUT, $WIMPORT || die " Kann $WIMPORT nicht zum lesen oeffnen!";
    while(<INPUT>) {
                if( /^$room;.*?;.*?;.*?;(.*?);.*$/ ){
                push @hosts, $1;
                }
        }
    }
